/* K2-13@t\\ */

#include <stdio.h>

typedef struct {
	int y;		/* N */
	int m;		/* i1`12j*/
	int d;		/* i1`31j*/
} Date;

Date Before(Date x, int n);
Date After( Date x, int n);

/*--- e̓ ---*/
static int  mdays[2][13] = {
	{31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},	/* N */
	{31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},	/* [N */
};

/*--- yearN͉[N ---*/
int isleap(int year)
{
	return year % 4 == 0  &&  year % 100 != 0  ||  year % 400 == 0;
}

/*--- yNmd\\̂ԋp֐DateOf ---*/
Date DateOf(int y, int m, int d)
{
	Date temp;

	temp.y = y;
	temp.m = m;
	temp.d = d;

	return temp;
}

/*--- txn̓tԂ ---*/
Date After(Date x, int n)
{
	if (n < 0)
		return Before(x, -n);

	x.d += n;

	while (x.d > mdays[isleap(x.y)][x.m - 1]) {
		x.d -= mdays[isleap(x.y)][x.m - 1];
		if (++x.m > 12) {
			x.y++;
			x.m = 1;
		}
	}
	return x;
}

/*--- txnO̓tԂ ---*/
Date Before(Date x, int n)
{
	if (n < 0)
		return After(x, -n);

	x.d -= n;

	while (x.d < 1) {
		if (--x.m < 1) {
			x.y--;
			x.m = 12;
		}
		x.d += mdays[isleap(x.y)][x.m - 1];
	}

	return x;
}

/*--- t\ ---*/
int Print(Date x)
{
	int y = x.y;
	int m = x.m;
	int d = x.d;

	char *ws[] = {"", "", "", "", "", "", "y"};
	if (m == 1 || m == 2) {
		y--;
		m += 12;
	}
	printf("%04dN%02d%02d(%s)", x.y, x.m, x.d, 
			ws[(y + y/4 - y/100 + y/400 + (13*m+8)/5 + d) % 7]);
}

int main(void)
{
	int n;
	int y, m, d;
	Date x;

	printf("t͂ĂB\n");
	printf("NF");  scanf("%d", &y);
	printf("F");  scanf("%d", &m);
	printf("F");  scanf("%d", &d);

	x = DateOf(y, m, d);

	printf("O^̓t߂܂F");
	scanf("%d", &n);

	printf("%d̓tF", n);   Print(After(x, n));   putchar('\n');

	printf("%dO̓tF", n);   Print(Before(x, n));  putchar('\n');

	return 0;
}
